/*
 *   FreeAdhocUDF - copyright (c) 2004/2006 adhoc dataservice GmbH
 *   Christoph Theuring / Peter Mandrella / Georg Horn
 *   (bug-)reports only to udf@adhoc-data.de
 *   based on FreeUDFLibC - copyright (c) 1999 Gregory Deatz
 *   Declarations script for new FreeAdhocUDF UDFs
 *   Notice: to use with dialect 1 (DATE-field is timestamp)
 *   Notice: to use with dialect 3 (DATE-field is date)
 *   please comment/uncomment which dialect you want
 *   length of some cstring = 8190 or 4095 
 *   because so you can use one this UDF 4 (8) times in a piped string
 *   4 x 8190 = 32760 < 32762 (15 bit - 6 bit internal use)
 *
 *   new FreeAdhocUDF functions of version adhoc 20061031
 *   functions in locical order 
 */

// SET SQL DIALECT 1;
SET SQL DIALECT 3;

DECLARE EXTERNAL FUNCTION F_DQM
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'dqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTRANDOM
    INTEGER,
    INTEGER
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'intrandom' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NBSP
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'nbsp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SQM
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAB
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'tab' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MAC
    CSTRING(36)
    RETURNS PARAMETER 1
    ENTRY_POINT 'uuid1mac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1RAND
    CSTRING(36)
    RETURNS PARAMETER 1
    ENTRY_POINT 'uuid1rand' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID4
    CSTRING(36)
    RETURNS PARAMETER 1
    ENTRY_POINT 'uuid4' MODULE_NAME 'FreeAdhocUDF';
  
DECLARE EXTERNAL FUNCTION F_UUID1MACCOMPR
    CSTRING(22)
    RETURNS PARAMETER 1
    ENTRY_POINT 'uuid1maccompr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1RANDCOMPR
    CSTRING(22)
    RETURNS PARAMETER 1
    ENTRY_POINT 'uuid1randcompr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID4COMPR
    CSTRING(22)
    RETURNS PARAMETER 1
    ENTRY_POINT 'uuid4compr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID2UUIDCOMPR
    CSTRING(254),
    CSTRING(22)
    RETURNS PARAMETER 2
    ENTRY_POINT 'compressuuid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUIDCOMPR2UUID
    CSTRING(254),
    CSTRING(36)
    RETURNS PARAMETER 2
    ENTRY_POINT 'expanduuidcompr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUIDCOMPARE
    CSTRING(254),
    CSTRING(254)
    RETURNS INTEGER BY VALUE
    ENTRY_POINT 'uuid_compare' MODULE_NAME 'FreeAdhocUDF';
  
DECLARE EXTERNAL FUNCTION F_UUID1TIMESTAMP
    CSTRING(254)
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'uuid1timestamp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1COMPRTIMESTAMP
    CSTRING(254)
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'uuid1comprtimestamp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MACMAC
    CSTRING(254),
    CSTRING(17)
    RETURNS PARAMETER 2
    ENTRY_POINT 'uuid1macmac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUID1MACCOMPRMAC
    CSTRING(254),
    CSTRING(17)
    RETURNS PARAMETER 2
    ENTRY_POINT 'uuid1maccomprmac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UUIDVERSION
    CSTRING(254),
    CSTRING(20)
    RETURNS PARAMETER 2
    ENTRY_POINT 'uuidversion' MODULE_NAME 'FreeAdhocUDF';

/* adhoc 2006-10-31 */
