/*
 * FreeAdhocUDF - copyright (c) 2004 - 2006 adhoc dataservice GmbH
 * Christoph Theuring / Peter Mandrella / Georg Horn
 * based on FreeUDFLibC - copyright (c) 1999 Gregory Deatz
 *
 * File Name:	math_functions.h
 * Description: This header contains the prototype definitions for math_functions.c
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *  pm = added by Peter Mandrella
 *
 *  Math routines declarations:
 *
 *       convertfrom33 - convert a string (base33) to an integer
 *       convertto33 - convert an integer to base33 string
 *       convertfrombase - convert a string (base<n>) to an integer
 *       converttobase - convert an integer to a base<n> string
 *       converttodollar - convert a double to a dollar string ($xxxx.xx)
 *  pm   degtorad - converts radiants number to degrees
 *       doubleabs - get the absolute value of a double
 *  pm   equalfloat - compare two float numbers
 *  pm   equalinteger - compare two integer numbers
 *  pm   fact - calculate faculty
 *       fixedpoint - convert a double to a string with <n> decimal points
 *  pm   fixedpointlang - versatile double to string conversion; correct rounding
 *  pm   hextoint - convert hexadecimal string to integer
 *       integerabs - get the absolute value of an integer
 *  pm   inttohex - convert integer number to hexadecimal string
 *  pm   isdivisibleby - test, if first number multiple of second number?
 *  pm   maxnum - maximum of two numbers
 *  pm   minnum - minimum of two numbers
 *       modulo - perform modulo arithmetic
 *  pm   prozente
 *  pm   radtodeg - converts degrees number to radiants
 *       round - round a double to the nearest integer
 *       truncate - return the integer part of a double
 *  pm   zahlrunden - round double value with fixed number of decimals
 */

int convertfrom33 PROTO_LIST ((char *));
char * convertto33 PROTO_LIST ((int *));
int convertfrombase PROTO_LIST ((char *, int *, char *));
char * converttobase PROTO_LIST ((int *, int *, char *));
char * converttodollar PROTO_LIST ((double *));
double doubleabs PROTO_LIST ((double *));
double fact PROTO_LIST ((int *));
char * fixedpoint PROTO_LIST ((double *, int *));
char * fixedpointlang PROTO_LIST ((double *, int *, char *, char *));
int integerabs PROTO_LIST ((int *));
double maxnum PROTO_LIST ((double *, double *));
double minnum PROTO_LIST ((double *, double *));
int modulo PROTO_LIST ((int *, int *));
int round PROTO_LIST ((double *));
int truncate PROTO_LIST ((double *));
int isdivisibleby PROTO_LIST ((int*, int*));

int equalfloat PROTO_LIST ((double *, double *));
int equalinteger PROTO_LIST ((int *, int *));
double prozente PROTO_LIST ((double *, double *));
double zahlrunden PROTO_LIST ((double *, int *));
char * inttohex PROTO_LIST ((int *, int *));
int hextoint PROTO_LIST ((char *));
double degtorad PROTO_LIST ((double *));
double radtodeg PROTO_LIST ((double *));
int intrandom PROTO_LIST (( int *, int *));

// Integer-Parameter sind Zeiger !!!

